require 'player'
require 'justice'
require 'valery'
require 'rory'
require 'nightshine'
function menu_load()
started = false
selectSFX = love.audio.newSource('sounds/select.mp3','static')
font = love.graphics.newFont('fonts/verminvibes.ttf',30)
love.graphics.setNewFont('fonts/verminvibes.ttf',90)
character_selection_fullscreen = love.graphics.newImage('ui/character-select-fullscreen.png')
music = {}
music.song = love.audio.newSource('sounds/song1.mp3',"stream")
music.song:setLooping(true)
music.song:play()
end

function menu_update(dt)

    


        
end

function menu_draw()
    
    local screenWidth = love.graphics.getWidth()
    local screenHeight = love.graphics.getHeight()
    local leftDistance = screenWidth * 0.245 --distance to left corner of left collumn from screenWidth
    local rightDistance = screenWidth * 0.165 --distance to left corner of right collumn from screenWidth
    local upDistance = 100 --distance to left corner of both collumns from 0
    local gutter = 22 -- space between portraits
    local size = 128 -- size of portraits
    if state == "startscreen" then
       displayCharacters()
        

        love.graphics.setBackgroundColor(0.3,0.8,0.8)
        love.graphics.print("Choose Your Characters!",10,0)
           

        --character portraits
        love.graphics.draw(justice.portrait,screenWidth - leftDistance,upDistance,nil,2,nil)
        love.graphics.draw(valery.portrait,screenWidth - leftDistance+size+gutter,upDistance,nil,2,nil)
        love.graphics.draw(rory.portrait,screenWidth - leftDistance,upDistance+size+gutter,nil,2,nil)
        love.graphics.draw(beetle.portrait,screenWidth - leftDistance+size+gutter,upDistance+size+gutter,nil,2,nil)
        love.graphics.draw(puppet.portrait,screenWidth - leftDistance,upDistance + 2*size + 2*gutter,nil,2,nil)
        love.graphics.draw(dennis.portrait,screenWidth - leftDistance+size+gutter,upDistance + 2*size + 2*gutter,nil,2,nil)
        love.graphics.draw(nightshine.portrait,screenWidth - leftDistance,upDistance + 3*size + 3*gutter,nil,2,nil)
        love.graphics.draw(justice.portrait,screenWidth - leftDistance+size+gutter,upDistance + 3*size + 3*gutter,nil,2,nil)
        love.graphics.draw(justice.portrait,screenWidth - leftDistance,upDistance + 4*size + 4*gutter,nil,2,nil)
        love.graphics.draw(justice.portrait,screenWidth - leftDistance+size+gutter,upDistance + 4*size + 4*gutter,nil,2,nil)
        
        love.graphics.rectangle('fill',screenWidth - leftDistance+10,upDistance + 5*size + 5*gutter,256,100)
     
        local blue = {0,0,1}
        love.graphics.print({blue, "START"}, screenWidth - leftDistance + 10, upDistance + 5*size + 5*gutter)
        
        
    
    else
    player_draw()
    world_draw()
    end
end

function love.mousepressed(x,y,button,istouch)
    local mouseX, mouseY = love.mouse.getPosition()
    
    local screenWidth = love.graphics.getWidth()
    local screenHeight = love.graphics.getHeight()
    local leftDistance = screenWidth * 0.245 --distance to left corner of left collumn from screenWidth
    local rightDistance = screenWidth * 0.165 --distance to left corner of right collumn from screenWidth
    local upDistance = 100 --distance to left corner of both collumns from 0
    local gutter =  22 -- space between portraits
    local size = 128 -- size of portraits

    if state == "startscreen" then
        
        if button == 1 and  mouseX > screenWidth-leftDistance and mouseX < screenWidth - leftDistance + size and mouseY > upDistance and mouseY < upDistance+size then
        table.insert(selected_character,justice)
            love.graphics.print("selected justice",750,650)
            if character_1 ~= justice and character_1 == nil then
                character_1 = justice
                selectSFX:play()
            elseif character_2 ~= justice and character_1 ~= justice and character_2 == nil then
                character_2 = justice
                selectSFX:play()
            elseif character_3 ~= justice and character_1 ~= justice and character_2 ~= justice and character_3 == nil then
                character_3 = justice
                selectSFX:play()
            end
        end

        if button == 1 and mouseX > screenWidth - leftDistance+size+gutter and mouseX < screenWidth - leftDistance+size+gutter + size and mouseY > upDistance and mouseY < upDistance + size  then
            table.insert(selected_character,valery)
            if character_1 ~= valery and character_1 == nil then
                character_1 = valery
                selectSFX:play()
            elseif character_2 ~= valery and character_1 ~= valery and character_2 == nil then
                character_2 = valery
                selectSFX:play()
            elseif character_3 ~= valery and character_1 ~= valery and character_2 ~= valery and character_3 == nil then
                character_3 = valery
                selectSFX:play()
            end
        end

        if button == 1 and mouseX > screenWidth-leftDistance and mouseX < screenWidth-leftDistance+size and mouseY > upDistance + size + gutter and mouseY < upDistance + size + gutter + size  then
            table.insert(selected_character,rory)
            if character_1 ~= rory and character_1 == nil then
                character_1 = rory
                selectSFX:play()
            elseif character_2 ~= rory and character_1 ~= rory and character_2 == nil then
                character_2 = rory
                selectSFX:play()
            elseif character_3 ~= rory and character_1 ~= rory and character_2 ~= rory and character_3 == nil then
                character_3 = rory
                selectSFX:play()
            end
        end

        if button == 1 and mouseX > screenWidth - leftDistance+size+gutter and mouseX < screenWidth - leftDistance+size+gutter +size and mouseY > upDistance + size + gutter and mouseY < upDistance + size + gutter + size then
            table.insert(selected_character,beetle)
            if character_1 ~= beetle and character_1 == nil then
                character_1 = beetle
                selectSFX:play()
            elseif character_2 ~= beetle and character_1 ~= beetle and character_2 == nil then
                character_2 = beetle
                selectSFX:play()
            elseif character_3 ~= beetle and character_1 ~= beetle and character_2 ~= beetle and character_3 == nil then
                character_3 = beetle
                selectSFX:play()
            end
        end

        if button == 1 and mouseX > screenWidth-leftDistance  and mouseX < screenWidth-leftDistance +size and mouseY > 2*size + 2*gutter + upDistance and mouseY < 2*size + 2*gutter + upDistance + size then
            table.insert(selected_character,puppet)
            if character_1 ~= puppet and character_1 == nil then
                character_1 = puppet
                selectSFX:play()
            elseif character_2 ~= puppet and character_1 ~= puppet and character_2 == nil then
                character_2 = puppet
                selectSFX:play()
            elseif character_3 ~= puppet and character_1 ~= puppet and character_2 ~= puppet and character_3 == nil then
                character_3 = puppet
                selectSFX:play()
            end
        end

        if button == 1 and mouseX > screenWidth - leftDistance+size+gutter  and mouseX < screenWidth - leftDistance+size+gutter +size and mouseY > 2*size + 2*gutter + upDistance and mouseY < 2*size + 2*gutter + upDistance + size then
            table.insert(selected_character,dennis)
            if character_1 ~= dennis and character_1 == nil then
                character_1 = dennis
                selectSFX:play()
            elseif character_2 ~= dennis and character_1 ~= dennis and character_2 == nil then
                character_2 = dennis
                selectSFX:play()
            elseif character_3 ~= dennis and character_1 ~= dennis and character_2 ~= dennis and charac8ter_3 == nil then
                character_3 = dennis
                selectSFX:play()
            end
        end

        if button == 1 and mouseX > screenWidth-leftDistance  and mouseX < screenWidth-leftDistance +size and mouseY > 3*size + 3*gutter + upDistance and mouseY < 3*size + 3*gutter + upDistance + size then
            table.insert(selected_character,puppet)
            if character_1 ~= nightshine and character_1 == nil then
                character_1 = nightshine
                selectSFX:play()
            elseif character_2 ~= nightshine and character_1 ~= nightshine and character_2 == nil then
                character_2 = nightshine
                selectSFX:play()
            elseif character_3 ~= nightshine and character_1 ~= nightshine and character_2 ~= nightshine and character_3 == nil then
                character_3 = nightshine
                selectSFX:play()
            end
        end

    end
    
    if button ==1 and mouseX > screenWidth - leftDistance + 10 and mouseX < screenWidth - screenWidth * 0.1 and mouseY > upDistance + 5*size + 5*gutter and mouseY < upDistance + 6*size + 6*gutter - 50 and character_1 ~= nil and character_2 ~= nil
    and character_3 ~= nil then
        state = "playing"
        selectSFX:play()
    end
    
end

function displayCharacters()
    local mouseX, mouseY = love.mouse.getPosition()
    
    local screenWidth = love.graphics.getWidth()
    local screenHeight = love.graphics.getHeight()
    local leftDistance = screenWidth * 0.245 --distance to left corner of left collumn from screenWidth
    local rightDistance = screenWidth * 0.165 --distance to left corner of right collumn from screenWidth
    local upDistance = 100 --distance to left corner of both collumns from 0
    local gutter =  22 -- space between portraits
    local size = 128 -- size of portraits
    love.graphics.draw(character_selection_fullscreen,0,0,nil,8.0,nil)
    love.graphics.rectangle('fill',screenWidth - 480 ,upDistance-10,300,750)

    debugDraw()

    --1440 90 1750 840
    if  mouseX > screenWidth-leftDistance and mouseX < screenWidth - leftDistance + size and mouseY > upDistance and mouseY < upDistance+size then
           
        justice.animations.idle:draw(justice.idleSheet,screenWidth/2-320,screenHeight/2 - 240,nil,3.0)
        love.graphics.print("Justice",750,750)
    end

        if  mouseX > screenWidth - leftDistance+size+gutter and mouseX < screenWidth - leftDistance+size+gutter + size and mouseY > upDistance and mouseY < upDistance + size  then
            valery.animations.idle:draw(valery.idleSheet,screenWidth/2-320,screenHeight/2 - 240,nil,3.0)
            love.graphics.print("Valery",750,750)
        end

        if  mouseX > screenWidth-leftDistance and mouseX < screenWidth-leftDistance+size and mouseY > upDistance + size + gutter and mouseY < upDistance + size + gutter + size  then
            rory.animations.idle:draw(rory.idleSheet,screenWidth/2-320,screenHeight/2 - 240,nil,3.0)
            love.graphics.print("Rory",750,750)
        end

        if mouseX > screenWidth - leftDistance+size+gutter and mouseX < screenWidth - leftDistance+size+gutter+size and mouseY > upDistance + size + gutter and mouseY < upDistance + size + gutter + size then
            love.graphics.draw(beetle.sprite,screenWidth/2-320,screenHeight/2 - 240,nil,3.0)
            love.graphics.print("Beetle",750,750)
        end

        if mouseX > screenWidth-leftDistance  and mouseX < screenWidth-leftDistance +size and mouseY > 2*size + 2*gutter + upDistance and mouseY < 2*size + 2*gutter + upDistance + size then
            love.graphics.draw(puppet.sprite,screenWidth/2-320,screenHeight/2 - 240,nil,3.0)
            love.graphics.print("Alice",750,750)
        end

        if mouseX > screenWidth - leftDistance+size+gutter  and mouseX < screenWidth - leftDistance+size+gutter +size and mouseY > 2*size + 2*gutter + upDistance and mouseY < 2*size + 2*gutter + upDistance + size then
            love.graphics.draw(dennis.sprite,screenWidth/2-320,screenHeight/2 - 240,nil,3.0)
            love.graphics.print("Dennis",750,750)
        end

        if mouseX > screenWidth-leftDistance  and mouseX < screenWidth-leftDistance +size and mouseY > 3*size + 3*gutter + upDistance and mouseY < 3*size + 3*gutter + upDistance + size then
            nightshine.animations.idle:draw(nightshine.idleSheet,screenWidth/2-320,screenHeight/2 - 240,nil,3.0)
            love.graphics.print("Nightshine",750,750)
        end
end