function justice_load()
--justice character
justiceSideSpecialCD = 0

justice = {}
justice.speed = 1000
justice.sprite = love.graphics.newImage('sprites/justice/justice.png')
justice.forwardSheet = love.graphics.newImage('sprites/justice/justice-walk.png')
justice.idleSheet = love.graphics.newImage('sprites/justice/justice-idle.png')
justice.forwardSpecialSheet = love.graphics.newImage('sprites/justice/justice-side-special.png')
justice.forwardgrid = anim8.newGrid(160,160,justice.forwardSheet:getWidth(),justice.forwardSheet:getHeight() )
justice.idlegrid = anim8.newGrid(160,160,justice.idleSheet:getWidth(),justice.idleSheet:getHeight())
justice.forwardSpecialgrid = anim8.newGrid(160,160,justice.forwardSpecialSheet:getWidth(),justice.idleSheet:getHeight())
justice.portrait = love.graphics.newImage('sprites/justice/justice-portrait.png')

justice.animations = {}
justice.animations.forward = anim8.newAnimation(justice.forwardgrid('1-8',1),0.055)
justice.animations.idle = anim8.newAnimation(justice.idlegrid('1-4',1),0.1)
justice.animations.forwardspecial=anim8.newAnimation(justice.forwardSpecialgrid('1-15',1),0.1)

end

function justice_animations_update(dt)
    justice.animations.forward:update(dt)
    justice.animations.idle:update(dt)
    justice.animations.forwardspecial:update(dt)
end

function justice_moves_update(dt)

justice_sidespecial(dt)

end



function justice_sidespecial(dt)

   
    
    justiceSideSpecialCD = justiceSideSpecialCD- 600 *dt

    if justiceSideSpecialCD < 0 then
        justiceSideSpecialCD = 0
    end

    if love.keyboard.isDown('d','right') and love.keyboard.isDown('f') and justiceSideSpecialCD == 0  then

        player.state = "rightspecial"
        

    end

    if love.keyboard.isDown('a','left') and love.keyboard.isDown('f') and justiceSideSpecialCD == 0  then

        player.state = "leftspecial"
        

    end

    if player.state == "rightspecial" and character_1 == justice and player.active == 1 or 
    player.state == "rightspecial" and character_2 == justice and player.active == 2 or 
    player.state == "rightspecial" and character_3 == justice and player.active ==3 then 

       
        justiceSideSpecialCD = justiceSideSpecialCD + 1000 * dt
    end

    if player.state == "leftspecial" and character_1 == justice and player.active == 1 or 
    player.state == "leftspecial" and character_2 == justice and player.active == 2 or 
    player.state == "leftspecial" and character_3 == justice and player.active ==3 then 

        justiceSideSpecialCD = justiceSideSpecialCD + 1000 * dt
       

    end



end